/*
* Disponible en http://www.kazak.ws
*
* Desarrollado por Soluciones KAZAK 
* Grupo de Investigacion y Desarrollo de Software Libre
* Santiago de Cali/Republica de Colombia 2001
*
* CLASS ConRegister v 0.1                                            
* Esta clase define la estructura de datos de los registros de      
* conexin.                                                         
* Los objetos de este tipo se crean desde las clases ConfigFileReader,       
* ConnectWin, PGConection y UpdateDBTree. Las clases XPg, BuildConfigFile 
* y Proof tambin utilizan objetos de este tipo. 
*                                                                   
* Preguntas, Comentarios y Sugerencias: xpg@kazak.ws
*
* Fecha: 2001/07/31                                                 
*
* Autores: Beatriz Florin  - bettyflor@kazak.ws                    
*          Gustavo Gonzalez - xtingray@kazak.ws
*/

public class ConRegister {

 String Hostname;
 String Username;
 String Database;
 String Password = "";
 int Port;
 String Choosed = "";

 /**
  * METODO CONSTRUCTOR 1ra. Opcin
  * Define la estructura de datos para leer el archivo de configuracin
  */
 public ConRegister(String Host, String DB, String User,int numPort) 
  {
   Hostname = Host;
   Database = DB;
   Username = User;
   Port = numPort;
  }
 
 public ConRegister(String Host, String DB, String User,int numPort,String selected) 
  {
   Hostname = Host;
   Database = DB;
   Username = User;
   Port = numPort;
   Choosed = selected;
  }
 
 /**
  * METODO CONSTRUCTOR 2da. Opcin
  * Define la estructura de datos para hacer pruebas de conexin
  */
 public ConRegister(String Host, String DB, String User, String Clave, int numPort) 
  {
   Hostname = Host;
   Database = DB;
   Username = User;
   Password = Clave;
   Port = numPort;
  }

 /**
  * Mtodo getHost
  * Retorna el nombre del servidor en el registro actual
  */
 public String getHost() 
 {
  return Hostname;	
 }

 /**
  * Mtodo getUser
  * Retorna el nombre del usuario en el registro actual
  */
 public String getUser() 
 {
  return Username;	
 }

 /**
  * Mtodo getPassword
  * Retorna la clave del usuario en el registro actual
  */
 public String getPassword()
 {
  return Password;
 }

 /**
  * Mtodo getDatabase
  * Retorna el nombre de la base de datos en el registro actual
  */
 public String getDatabase() 
 {
  return Database;	
 }

 /**
  * Mtodo getPort
  * Retorna el nmero del puerto en el registro actual
  */
 public int getPort() 
 {
  return Port;	
 }

 public String getDBChoosed()
 {
  return Choosed;
 }

} //Fin de la Clase
